# -*- coding: utf-8 -*-
from PyQt4.QtGui import QProgressBar
from PyQt4.QtCore import *

# Имена проверяемых векторных слоёв
layerPolygonName    = u'UCH_LESNICHESTVO'
layerPointName      = u'1468ppn'

# Имена одинаковых по значению атрибутов
fieldPolygonName    = u'NAME'
fieldPointName      = u'Name'

layerPolygon    = None
providerPolygon = None
layerPoint      = None
providerPoint   = None
listIdPoint     = []

layersMap       = QgsMapLayerRegistry.instance()
layerPolygon    = layersMap.mapLayersByName(layerPolygonName)[0]
providerPolygon = layerPolygon.dataProvider()
layerPoint      = layersMap.mapLayersByName(layerPointName)[0]
providerPoint   = layerPoint.dataProvider()
countPoligones  = providerPolygon.featureCount()

progressMessageBar = iface.messageBar().createMessage(u'Обработка данных...')
progress = QProgressBar()
progress.setMaximum(countPoligones)
progress.setAlignment(Qt.AlignLeft|Qt.AlignVCenter)
progressMessageBar.layout().addWidget(progress)
iface.messageBar().pushWidget(progressMessageBar, iface.messageBar().INFO)

i = 0
for polygon in providerPolygon.getFeatures(QgsFeatureRequest()):
    geomPolygon = polygon.geometry()
    namePolygon = polygon.attribute(fieldPolygonName)
    if namePolygon != None:
        namePolygon = namePolygon.upper()
        searchCondition = '\"' +fieldPointName+ '\" = \'' +namePolygon+ '\''
        layerPoint.setSubsetString(searchCondition)

        for point in providerPoint.getFeatures(QgsFeatureRequest()):
            geomPoint = point.geometry()

            if not geomPolygon.contains(geomPoint):
                listIdPoint.append(point.id())
    
    i += 1
    progress.setValue(i)

if len(listIdPoint) > 0:
    for everyId in listIdPoint:
        layerPoint.select(everyId)

layerPoint.setSubsetString(None)
iface.mapCanvas().refresh()
iface.messageBar().clearWidgets()
